Agora C++ API Reference for All Platforms

Loading...
Searching...
No Matches
Public Attributes | List of all members
agora::rtc::ILocalUser::AudioProcessingStats Struct Reference

`#include <NGIAgoraLocalUser.h>`

## Public Attributes
agora::Optional< double > | echo_return_loss
agora::Optional< double > | echo_return_loss_enhancement
agora::Optional< double > | divergent_filter_fraction
agora::Optional< int32_t > | delay_median_ms
agora::Optional< int32_t > | delay_standard_deviation_ms
agora::Optional< double > | residual_echo_likelihood
agora::Optional< double > | residual_echo_likelihood_recent_max
agora::Optional< int32_t > | delay_ms

## Detailed Description

The statistics related to audio processing.

## Member Data Documentation

## ◆ echo_return_loss

agora::Optional<double> agora::rtc::ILocalUser::AudioProcessingStats::echo_return_loss

The echo return loss (ERL).

ERL = 10log_10(P_far / P_echo).

ERL measures the signal loss that comes back as an echo. A higher ratio corresponds to a smaller amount of echo. The higher the ERL the better.

## ◆ echo_return_loss_enhancement

agora::Optional<double> agora::rtc::ILocalUser::AudioProcessingStats::echo_return_loss_enhancement

The echo return loss enhancement (ERLE).

ERLE = 10log_10(P_echo / P_out).

The performance of an echo canceller is measured in echo return loss enhancement, which is the amount of additional signal loss applied by the echo canceller.

The total signal loss of the echo is the sum of ERL and ERLE.

## ◆ divergent_filter_fraction

agora::Optional<double> agora::rtc::ILocalUser::AudioProcessingStats::divergent_filter_fraction

The fraction of time that the AEC (Acoustic Echo Cancelling) linear filter is divergent, in a 1-second non-overlapped aggregation window.

## ◆ delay_median_ms

agora::Optional<int32_t> agora::rtc::ILocalUser::AudioProcessingStats::delay_median_ms

The delay metrics (ms).

It consists of the delay median and standard deviation. It also consists of the fraction of delay estimates that can make the echo cancellation perform poorly. The values are aggregated until the first call of getStatistics and afterwards aggregated and updated every second.

Note
  If there are several clients pulling metrics from `getStatistics` during a session, the first call from any of them will change to one second aggregation window for all.

## ◆ delay_standard_deviation_ms

agora::Optional<int32_t> agora::rtc::ILocalUser::AudioProcessingStats::delay_standard_deviation_ms

The delay standard deviation(ms).

## ◆ residual_echo_likelihood

agora::Optional<double> agora::rtc::ILocalUser::AudioProcessingStats::residual_echo_likelihood

The residual echo detector likelihood.

## ◆ residual_echo_likelihood_recent_max

agora::Optional<double> agora::rtc::ILocalUser::AudioProcessingStats::residual_echo_likelihood_recent_max

The maximum residual echo likelihood from the last time period.

## ◆ delay_ms

agora::Optional<int32_t> agora::rtc::ILocalUser::AudioProcessingStats::delay_ms

The instantaneous delay estimate produced in the AEC (ms). The value is the instantaneous value at the time of calling getStatistics.